
#include <DualG2HighPowerMotorShield.h>
DualG2HighPowerMotorShield24v14 md;
#define RECEIVE_PIN 3
#define CHANNEL_AMOUNT 8
#define DETECTION_SPACE 2500
#define METHOD RISING
const int deadzone = 20;
int ch[CHANNEL_AMOUNT + 1];
int move; // Forward/Back speed
int turn; // Turning Factor
void stopIfFault() //motor driver fault code
{
  if (md.getM1Fault())
  {
    md.disableDrivers();
  delay(1);
    Serial.println("M1 fault");
    while (1);
  }
  if (md.getM2Fault())
  {
    md.disableDrivers();
  delay(1);
    Serial.println("M2 fault");
    while (1);
  }
}

void setup()
{
Serial.begin(115200);
pinMode(RECEIVE_PIN, INPUT_PULLUP);
attachInterrupt(digitalPinToInterrupt(RECEIVE_PIN), ppm_interrupt, METHOD);
}

void loop()

{
  move = map(ch[3], 1000, 2000, -400, 400); //center over zero
    int moved = abs(move) < deadzone ? 0 : move;
    turn = map(ch[1], 1000, 2000, -400, 400);
    int turnd = abs(turn) < deadzone ? 0 : turn;
    if(turnd>0){md.setM2Speed(moved-turn); md.setM1Speed(moved);};
if(turnd<0){md.setM1Speed(moved-abs(turn)); md.setM2Speed(moved);}; 
  md.enableDrivers();
  delay(1);  // The drivers require a maximum of 1ms to elapse when brought out of sleep mode.

md.setM1Speed(moved);
   stopIfFault();

md.setM2Speed(moved);
   stopIfFault();    
Serial.println (moved);
Serial.println (turnd);
  
ppm_write();
}

void ppm_write()
{
static unsigned long int t;
if (millis() - t < 100)
return 0;
for (byte i = 0; i < CHANNEL_AMOUNT + 1; i++)
{
Serial.print(ch[i]);
Serial.print("\t");
}
Serial.print("\n");
t = millis();
}

void ppm_interrupt()
{
static byte i;
static unsigned long int t_old;
unsigned long int t = micros(); //store time value a when pin value falling/rising
unsigned long int dt = t - t_old; //calculating time inbetween two peaks
t_old = t;

if ((dt > DETECTION_SPACE) || (i > CHANNEL_AMOUNT))
{
i = 0;
}
ch[i++] = dt;
}
